;;;-----------------------------LICENSE NOTICE------------------------------------
;;;    This file is part of LOOPED; An Amstrad CPC Game
;;;    Copyright (C) 2020  Miguel Ángel García Pérez (kupier@outlook.com) / Alejandro Gomariz Núñez (alejandro126g@gmail.com)
;;;
;;;    This program is free software: you can redistribute it and/or modify
;;;    it under the terms of the GNU General Public License as published by
;;;    the Free Software Foundation, either version 3 of the License, or
;;;    (at your option) any later version.
;;;
;;;    This program is distributed in the hope that it will be useful,
;;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;    GNU General Public License for more details.
;;;
;;;    You should have received a copy of the GNU General Public License
;;;------------------------------------------------------------------------------
.include "cpctelera.h.s"
.include "assets/assets.h.s"
.include "cpct_functions.h.s"
.include "cmp/entity.h.s"
.include "man/entity.h.s"
.include "man/game.h.s"



man_animations_update::
    ld  hl,#man_animation_one_by_one
    ld  a,#e_type_animated
    call man_entity_forall
ret

man_animation_one_by_one:
    ld  a,e_type(ix)
    and  #e_type_input
    sub  #e_type_input
    jr  nz,no_es_personaje
_es_personaje:
    ;;miramos la velocidad para saber en la direccion en la que se dirige
    ld  a,e_vx(ix)
    or  a
    jr z,compr_vy ;;Comprobamos si la velocidad es 0 para asi no pasarle cambiarle ningun sprite

    add  #1
    jr  z,va_izq
    ;;sino va a la derecha
    ld  a,#7
    call change_animations
    jr  no_es_personaje
va_izq:
    ld  a,#9
    call change_animations
    jr no_es_personaje

compr_vy:
    ld  a,e_vy(ix)
    or  a
    jp z, animation_personaje_stop
    

    ld  b,#2
    sub a,b
    jr  z,abajo
    ld a,#3
    call change_animations
    ret
abajo:
    ld a,#0
    call change_animations
ret
no_es_personaje:
    ld  a,e_collisionst(ix)
    and  #e_collision_enemy
    sub  #e_collision_enemy
    jr nz,cambio_de_cristal
    call change_animations_enemy
    ret
cambio_de_cristal:
    ld  a,e_collisionst(ix)
    and  #0x10
    sub  #0x10
    ret nz
    ld  hl,#_cristal_sp_8
    ld  bc,#0x80
    call change_animations_generic
ret


change_animations:
    
    ld  hl,#_personaje_sp_00

    ld  (_ent_counter), a 
    _ent_counter = . +1
    ld  a, #0
    ld  b,e_pstr_counter(ix)
    add a,b
_loop:
    
    dec a
    jr  z,sal_bucle

    ld  (_ent_counter),a

    ld de, #0x62
    add hl, de
jr _loop

sal_bucle:

    ld  e_pspr_l(ix),l
    ld  e_pspr_h(ix),h
    ;;QUE LA ENTIDAD TENGA UN ATRIBUTO MAS COMO
    ;;UNA VARIABLE PARA QUE ESTE 1 2 3 CAMBIANDO LOS SPRITES
    ; Y CUANDO LLEGUE A 3 CAMBIAR AL PRIMERO OTRA VEZ
    ;ld  e_pstr_counter(ix),#0x03
    ld  a,e_pstr_counter(ix)
    dec a
    jr  z,change_valor
    ld  e_pstr_counter(ix),a

ret
change_valor:
    ld  e_pstr_counter(ix),#0x03
  
ret


change_animations_enemy:
    ld  a,e_pstr_counter(ix)
    sub a,#2
    jr  z,enemigos_sp_1

    ld  hl,#_enemigos_sp_0
    ld  e_pspr_l(ix),l
    ld  e_pspr_h(ix),h
    ld  a,e_pstr_counter(ix)
    dec a
    ld  e_pstr_counter(ix),a
ret
enemigos_sp_1:
    ld  hl,#_enemigos_sp_1
    ld  e_pspr_l(ix),l
    ld  e_pspr_h(ix),h
    ld  e_pstr_counter(ix),#3
ret

animation_personaje_stop::
    ld  hl,#_personaje_sp_12
    ld  e_pspr_l(ix),l
    ld  e_pspr_h(ix),h
ret




change_animations_cristal::
    
    ld  de,#_cristal_sp_0
    ld  l,e_pspr_l(ix)
    ld  h,e_pspr_h(ix)
    ld  a,e
    sub a,l
    jr  z,segunda_comprobacion

segunda_comprobacion:
    ld  a,d
    sub a,h
    jr  z,es_el_primer_sprite
    ld  hl,#_cristal_sp_2
    ld  e_pspr_l(ix),l
    ld  e_pspr_h(ix),h
    ret
es_el_primer_sprite:
    ld  hl,#_cristal_sp_1
    ld  e_pspr_l(ix),l
    ld  e_pspr_h(ix),h
ret


change_animations_generic:
    ;;en hl le pasamos el final
    ;; en bc le pasamos la diferencia que hay que sumar
    ld  e,e_pspr_l(ix)
    ld  d,e_pspr_h(ix)
    ld  a,e
    sub a,l
    jr  z, segunda_comprobacion_2
        call suma
    ret
segunda_comprobacion_2:
    ld  a,d
    sub a,h
    jr  z,destroy
    call suma
    ret
destroy:
    call man_entity_4destruction
ret

suma:
    ld  l,e_pspr_l(ix)
    ld  h,e_pspr_h(ix)
    add hl,bc
    ld  e_pspr_l(ix),l
    ld  e_pspr_h(ix),h
ret