;;;-----------------------------LICENSE NOTICE------------------------------------
;;;    This file is part of LOOPED; An Amstrad CPC Game
;;;    Copyright (C) 2020  Miguel Ángel García Pérez (kupier@outlook.com) / Alejandro Gomariz Núñez (alejandro126g@gmail.com)
;;;
;;;    This program is free software: you can redistribute it and/or modify
;;;    it under the terms of the GNU General Public License as published by
;;;    the Free Software Foundation, either version 3 of the License, or
;;;    (at your option) any later version.
;;;
;;;    This program is distributed in the hope that it will be useful,
;;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;    GNU General Public License for more details.
;;;
;;;    You should have received a copy of the GNU General Public License
;;;------------------------------------------------------------------------------
.include "cpctelera.h.s"
.include "sys/render.h.s"
.include "cpct_functions.h.s"
.include "man/menu.h.s"
.include "man/game.h.s"
.include "man/levels.h.s"
.include "cmp/entity.h.s"
.include "end_game.h.s"
.include "assets/assets.h.s"
.include "assets/screens/screen_menu_z.h.s"
.include "assets/screens/screen_end_game.h.s"
.include "assets/screens/screen_end_game_no_sombrero.h.s"
.include "assets/screens/screen_esc_end_game_z.h.s"
.include "man/entity.h.s"
.include "cmp/level_cmp.h.s"
.include "cmp/hud.h.s"
.include "sys/scores.h.s"


numero_0::    .asciz "0"
;----"00"
numero_1::    .asciz "1" 

numero_2::    .asciz "2" 

numero_3::    .asciz "3" 

numero_4::    .asciz "4"
   
numero_5::    .asciz "5"
 
numero_6::    .asciz "6"
 
numero_7::    .asciz "7"

numero_8::    .asciz "8"
 
numero_9::    .asciz "9"


puntuacionTotal::       .dw 0

intentosTotales::       .dw 0

movimientosTotales::    .dw 0




string_finish:              .asciz  "Congratulations"
string_press_to_finish:     .asciz  "Enter to reset"
string_score:               .asciz  "Your Score:"

man_end_game_init::
    dec a
    jr z,salta
    jr jump
salta:
    call sys_eren_init
    ld  hl,#_screen_esc_end_game_z_end
    ld  de,#0xFFFF
    call cpct_zx7b_decrunch_s_asm
    jr salta_4
jump:
    ld  a,(finalGame)
    cp  #0
    jr  z,comprobar_lo_de_la_pala
    jr  salta_3
comprobar_lo_de_la_pala:
    call man_entity_getArray
    ld  a,e_palas_obt(ix)
    cp  #0
    jr  z,sin_sombrero
salta_3:
    call sys_eren_init
    ld  hl,#_screen_end_game_end
    ld  de,#0xFFFF
    call cpct_zx7b_decrunch_s_asm
    jp salta_2
sin_sombrero:
    call sys_eren_init
    ld  hl,#_screen_end_game_no_sombrero_end
    ld  de,#0xFFFF
    call cpct_zx7b_decrunch_s_asm
salta_2:
salta_4:
    ld hl, #_level_2
    ld (puntero_2), hl
    ld (puntero_1), hl
    call sum_parcial_to_total
    
    push hl
    ld  bc,#1
    ld  hl,(puntuacionTotal)
    add hl,bc
    ld  (puntuacionTotal),hl
    ld  bc,(movimientosTotales)
    ld  (puntuacionTotal),hl
    pop hl

    
    call hud_init_movs
    call hud_init_lvls
    call hud_init_try
    

   
;;---------------------------------------------------
    ld  hl,(puntuacionTotal)
    call movements_to_digits
    ld  hl,#0x0006
    call cpct_setDrawCharM0_asm
    ld  a,(digito_3)
    ld  b,a
    call set_iy_number
   

    X = 40
    Y = 50
    ld  hl,#0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call cpct_drawStringM0_asm

    ld  hl,#0x0006
    call cpct_setDrawCharM0_asm
    ld  a,(digito_2)
    ld  b,a
    call set_iy_number
   

    X = 44
    Y = 50
    ld  hl,#0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call cpct_drawStringM0_asm


     ld  hl,#0x0006
    call cpct_setDrawCharM0_asm
    ld  a,(digito_1)
    ld  b,a
    call set_iy_number
   

    X = 48
    Y = 50
    ld  hl,#0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call cpct_drawStringM0_asm
;;-----------------------------------------------------
    call reset_digits
    ld  hl,(movimientosTotales)
    call movements_to_digits
    ld  hl,#0x0006
    call cpct_setDrawCharM0_asm
    ld  a,(digito_3)
    ld  b,a
    call set_iy_number
   

    X = 24
    Y = 85
    ld  hl,#0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call cpct_drawStringM0_asm

     ld  hl,#0x0006
    call cpct_setDrawCharM0_asm
    ld  a,(digito_2)
    ld  b,a
    call set_iy_number
   

    X = 28
    Y = 85
    ld  hl,#0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call cpct_drawStringM0_asm


    ld  hl,#0x0006
    call cpct_setDrawCharM0_asm
    ld  a,(digito_1)
    ld  b,a
    call set_iy_number
   

    X = 32
    Y = 85
    ld  hl,#0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call cpct_drawStringM0_asm
;---------------------------------------------------------------
    ;;-----------------------------------------------------
    call reset_digits
    ld  hl,(intentosTotales)
    call movements_to_digits
    ld  hl,#0x0006
    call cpct_setDrawCharM0_asm
    ld  a,(digito_3)
    ld  b,a
    call set_iy_number
   

    X = 24
    Y = 120
    ld  hl,#0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call cpct_drawStringM0_asm

     ld  hl,#0x0006
    call cpct_setDrawCharM0_asm
    ld  a,(digito_2)
    ld  b,a
    call set_iy_number
   

    X = 28
    Y = 120
    ld  hl,#0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call cpct_drawStringM0_asm


    ld  hl,#0x0006
    call cpct_setDrawCharM0_asm
    ld  a,(digito_1)
    ld  b,a
    call set_iy_number
   

    X = 32
    Y = 120
    ld  hl,#0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call cpct_drawStringM0_asm
;---------------------------------------------------------------

    

    call man_destroy_all_entities
    call man_end_game_terminate
ret


man_end_game_terminate:: ;;PRESS ESC

    call cpct_scanKeyboard_asm
    ld  hl,#Key_Return
    call cpct_isKeyPressed_asm
    jr z,man_end_game_terminate
    call man_menu_init
    call man_menu_run
    call man_game_init ;;
    
     
ret


set_iy_number:
    ld  a,b     ;;Copiamos b en a para hacer los calculos y asi no perdemos b que es donde tenemos nuestra varible
    sub #0
    jr  z,es_cero
    ld  a,b
    sub #1
    jr  z,es_uno
    ld  a,b
    sub #2
    jr  z,es_dos
     ld  a,b
    sub #3
    jr  z,es_tres
     ld  a,b
    sub #4
    jr  z,es_cuatro
     ld  a,b
    sub #5
    jr  z,es_cinco
     ld  a,b
    sub #6
    jr  z,es_seis
     ld  a,b
    sub #7
    jr  z,es_siete
     ld  a,b
    sub #8
    jr  z,es_ocho
     ld  a,b
    sub #9
    jr  z,es_nueve
ret
es_cero:
    ld  iy,#numero_0
    jp salir
es_uno:
    ld  iy,#numero_1
    jp salir
es_dos:
    ld  iy,#numero_2
    jp salir
es_tres:
    ld  iy,#numero_3
    jp salir
es_cuatro:
    ld  iy,#numero_4
    jp salir
es_cinco:
    ld  iy,#numero_5
    jp salir
es_seis:
    ld  iy,#numero_6
    jp salir
es_siete:
    ld  iy,#numero_7
    jp salir
es_ocho:
    ld  iy,#numero_8
    jp salir
es_nueve:
    ld  iy,#numero_9
salir:
ret