;;;-----------------------------LICENSE NOTICE------------------------------------
;;;    This file is part of LOOPED; An Amstrad CPC Game
;;;    Copyright (C) 2020  Miguel Ángel García Pérez (kupier@outlook.com) / Alejandro Gomariz Núñez (alejandro126g@gmail.com)
;;;
;;;    This program is free software: you can redistribute it and/or modify
;;;    it under the terms of the GNU General Public License as published by
;;;    the Free Software Foundation, either version 3 of the License, or
;;;    (at your option) any later version.
;;;
;;;    This program is distributed in the hope that it will be useful,
;;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;    GNU General Public License for more details.
;;;
;;;    You should have received a copy of the GNU General Public License
;;;------------------------------------------------------------------------------
.include "cpctelera.h.s"
.include "sys/ai_control.h.s"
.include "cmp/entity.h.s"
.include "sys/physics.h.s"
.include "sys/render.h.s"
.include "sys/input.h.s"
.include "man/entity.h.s"
.include "assets/assets.h.s"
.include "sys/cpct_collision.h.s"
.include "cpct_functions.h.s"
.include "man/levels.h.s"
.include "man/game.h.s"
.include "man/animations.h.s"
.include "man/end_game.h.s"





.module game_manager


;;------------------------
;;MANAGER CONFIGURATIONS CONSTANTS
;;------------------------

;;Manager_Member_Variables ---------CAMBIAR ESTOS VALORES DEL VIDEO
;;nivel 1
heroe:      DefineCmp_Entity  e_type_MovAARenAAinputAAcollider,24,160,0,0,7,14, _personaje_sp_12, e_ai_st_noAI,e_collision_wall 

reloj1:      DefineCmp_Entity  e_type_render,72,168,0,0,8,24, _arenas, e_ai_st_noAI,e_collision_wall 
reloj2:      DefineCmp_Entity  e_type_render,0,168,0,0,8,24, _arenas, e_ai_st_noAI,e_collision_wall 

puerta:      DefineCmp_Entity  e_type_MovAARenAAcolider,32,48,0,0,16,32, _puerta, e_ai_st_noAI,e_collision_stairs

;;Manager Public Functions
;;


man_game_init::
    call man_entity_init

    call man_entity_getArray
    call sys_ai_control_init
    call sys_eren_init
    call tilemap_init
    call sys_physics_init
    call sys_input_init


    ld  hl,#heroe
    call man_entity_create


    ld  hl,#puerta
    call man_entity_create
   ld  hl,#reloj1
    call man_entity_create
   ld  hl,#reloj2

    call man_entity_create

    ld  a,#0x01
    ld (fglobal),a
    ld  a,#0x0C ;;ESTO HAY QUE CAMBIARLO CADA VEZ QUE SE AÑADE UN NIVEL EN EL LEVELS;;---------------------------------------------
    ld  (finalGame),a
    
    ld  de,#_tilemap_01
    ld  (mapsGobl),de

    ld  bc,#0000
    ld  (puntuacionTotal),bc
    ld  (movimientosTotales),bc
    ld  (intentosTotales),bc

    call sys_render_hud_update
    
ret

;;;MAN GAME UPDATE

man_game_update::
    call man_set_level
    call man_entity_getArray
    call sys_input_update
    call man_entity_getArray
    call sys_ai_control_update
    call man_entity_getArray
    call sys_physics_update
    call man_entity_update
    call sys_collision_update
    call man_animations_update
     
ret


man_game_render::
    call man_entity_getArray
    call sys_eren_update
ret

man_game_reset_lvl:
    ld  a,e_type(ix)
    or  #e_type_reset
    ld  e_type(ix),a
ret