;;;-----------------------------LICENSE NOTICE------------------------------------
;;;    This file is part of LOOPED; An Amstrad CPC Game
;;;    Copyright (C) 2020  Miguel Ángel García Pérez (kupier@outlook.com) / Alejandro Gomariz Núñez (alejandro126g@gmail.com)
;;;
;;;    This program is free software: you can redistribute it and/or modify
;;;    it under the terms of the GNU General Public License as published by
;;;    the Free Software Foundation, either version 3 of the License, or
;;;    (at your option) any later version.
;;;
;;;    This program is distributed in the hope that it will be useful,
;;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;    GNU General Public License for more details.
;;;
;;;    You should have received a copy of the GNU General Public License
;;;------------------------------------------------------------------------------
.include "cpctelera.h.s"
.include "sys/render.h.s"
.include "cpct_functions.h.s"
.include "man/menu.h.s"
.include "man/game.h.s"
.include "man/levels.h.s"
.include "assets/screens/screen_esc_z.h.s"
.include "cmp/entity.h.s"
.include "man/entity.h.s"
.include "man/end_game.h.s"
.include "cmp/hud.h.s"



string_finish:              .asciz  "RESET BUTTON"
string_press_to_finish:     .asciz  "Enter to FINISH"
string_escape:              .asciz  "I haven't found the cap yet.Are you sure you want to reset?"

man_gameOver_init::
    call sys_eren_init

    ld  hl,#0x0002
    call cpct_setDrawCharM0_asm
    ld  iy,#string_finish
    X = 20
    Y = 80
    ld  hl,#0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call cpct_drawStringM0_asm

    ld  hl,#0x0004
    call cpct_setDrawCharM0_asm
    ld  iy,#string_press_to_finish
    X = 12
    Y = 120
    ld  hl,#0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    call cpct_drawStringM0_asm
    call man_destroy_all_entities_ex_heroe
    call man_gameOver_terminate
ret


comprobar_dead::
    call man_entity_getArray
    ld  a,e_type(ix)
    and #e_type_input
    sub #e_type_input
    jr  nz,man_gameOver_init

    ld  a,e_ai_aim_x(ix)
    cp  a,#3
    jr  z,try_again
    ret
    
try_again::
    ld  a,(fglobal)
    sub #1
    jr  z,nivel_1
    ld  de,(puntero_1)
    ld  (puntero_2),de
    call plus_intentos
    call cambiar_de_nivel
    ret
nivel_1:
    call man_game_init
ret

man_gameOver_terminate:: ;;PRESS ESC

    call cpct_scanKeyboard_asm
    ld  hl,#Key_Y
    call cpct_isKeyPressed_asm
    jr z,Key_Y_not_pressed
    call reset_punteros
    call hud_init_lvls
    call hud_init_movs
    call hud_init_try
    call man_destroy_all_entities_ex_heroe
    ld  a,#1
    call man_end_game_init
    ;call man_game_init ;;
    ret
Key_Y_not_pressed:
    ld  hl,#Key_N
    call cpct_isKeyPressed_asm
    jr  z,man_gameOver_terminate
    call comprobar_nivel
    call update_tilemap
    call sys_render_hud_update

ret


are_you_sure_to_reset::
    call sys_eren_init
    ld  hl,#_screen_esc_z_end
    ld  de,#0xFFFF
    call cpct_zx7b_decrunch_s_asm
    call man_gameOver_terminate
ret

