;;;-----------------------------LICENSE NOTICE------------------------------------
;;;    This file is part of LOOPED; An Amstrad CPC Game
;;;    Copyright (C) 2020  Miguel Ángel García Pérez (kupier@outlook.com) / Alejandro Gomariz Núñez (alejandro126g@gmail.com)
;;;
;;;    This program is free software: you can redistribute it and/or modify
;;;    it under the terms of the GNU General Public License as published by
;;;    the Free Software Foundation, either version 3 of the License, or
;;;    (at your option) any later version.
;;;
;;;    This program is distributed in the hope that it will be useful,
;;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;    GNU General Public License for more details.
;;;
;;;    You should have received a copy of the GNU General Public License
;;;------------------------------------------------------------------------------
.include "cpctelera.h.s"
.include "sys/ai_control.h.s"
.include "cmp/entity.h.s"
.include "sys/physics.h.s"
.include "sys/render.h.s"
.include "sys/input.h.s"
.include "man/entity.h.s"
.include "man/end_game.h.s"
.include "assets/assets.h.s"
.include "sys/cpct_collision.h.s"
.include "cpct_functions.h.s"
.include "man/levels.h.s"
.include "cmp/level_cmp.h.s"
.include "cmp/hud.h.s"
.include "sys/scores.h.s"


fglobal::               .db 0x01 ;;Nivel global
mapsGobl::              .dw 0x0000
num_repeticiones:       .db 0    
puntero_1::             .dw #_level_2 ;;--Los dos punteros apuntan al principio
puntero_2::             .dw #_level_2 ;;--

villian_horizontal::    DefineCmp_Entity  e_type_MovAARenAAcolider,40,72,1,0,8,16, _enemigos_sp_0, e_ai_st_noAI,e_collision_enemy
villian_vertical::      DefineCmp_Entity  e_type_MovAARenAAcolider,40,72,0,2,8,16, _enemigos_sp_0, e_ai_st_noAI,e_collision_enemy

hole:                   DefineCmp_Entity  e_type_MovAARenAAcolider,56,72,0,0,8,16, _hole_sp_0, e_ai_st_noAI,e_collision_stairs
pala:                   DefineCmp_Entity  e_type_ColAARen,0,0,0,0,7,14,_pala_sp,e_ai_st_noAI,e_collision_pala
cristal:                DefineCmp_Entity  e_type_ColAARen,0,0,0,0,8,16,_cristal_sp_0,e_ai_st_noAI,e_collision_wall



cristal_horizontal:       DefineCmp_Entity  e_type_ColAARen,0,40,1,0,8,16,_cristal_sp_0,e_ai_st_noAI,e_collision_wall
sombrero:                 DefineCmp_Entity  e_type_ColAARen,60,88,0,0,8,16,_sombrero_sp,e_ai_st_noAI,e_collision_stairs

comprobar_nivel:
   
    call man_entity_getArray
    ld  a,(fglobal) 
    ld  c,e_ai_aim_y(ix) 
    cp a,c 
    ret z ;;2 -1 = 1

change_level:
    inc a
    ld  (fglobal),a ;; 1+1 = 2 && 2
    ld  de,(puntero_2)
    ld  (puntero_1),de
    ld  a,(finalGame)
    dec a
    ld  (finalGame),a
    jp  z,man_end_game_init
    call change_sprite_lvls
    call hud_init_movs
    call hud_init_try
    call sum_parcial_to_total
    push hl
    ld  bc,#1
    ld  hl,(puntuacionTotal)
    add hl,bc
    ld  (puntuacionTotal),hl
    pop hl
    call cambiar_de_nivel
    ;;Ncesita las entidades nuevas 
    ;;borrar las antiguas
    ;;mapas

ret


cambiar_de_nivel::
    ;;Cuando se cambia de nivel o se reinicia se tienen en cuenta
    ;;que hay que destruir y volver a crear otra vez las variables
    call man_destroy_all_entities_ex_heroe
    call reset_values

    ld  e_palas_obt(ix),#0
    ld  e_ai_aim_x(ix),#0
    ld  a,e_movimientos(ix)
    
    ld  a,e_intentos(ix)
    ;ld  e_movimientos(ix),#0
    ld  e_intentos(ix),#0
    ;;Lo primero que hacemos es restablecer
    ;;el nº de veces movs del bucle
    call set_velocity_to_zero
    ;;Ponemos las variables de la velocidad a 0
     
  
    ;;Cargamos el 2º punteo que es el q se va a mover
    ld  bc, (puntero_1)
    ld	hl, (puntero_2)
    ld  a,(hl)
    
   
    ld 	e,(hl)
    inc hl
    ld	d,(hl)	
    ld (mapsGobl),de
    

    ld  (puntero_2),hl   ;;ACTULIZAR LOS PUNTEROS NO HACER ESTO
    ld  (puntero_1),bc
    salta_2:  
                        ;;ld (puntero_2),hl
    
    call update_tilemap
    ld  hl,(puntero_2)     ;;Recuperamos los registros que podian haberse destruido
    ld  bc,(puntero_1)

    inc hl              ;;Ahora cargamos las pos del personaje
 
    ;;------------------------------------------
    ;;Pos del personaje
    ;;------------------------------------------
    call man_entity_getArray



    ld  d,(hl)
    ld  e_x(ix),d



    inc hl
    ld  d,(hl)
    ld  e_y(ix),d
   

    ld  (puntero_2),hl   ;;ACTULIZAR LOS PUNTEROS NO HACER ESTO
    ld  (puntero_1),bc

    ;;;actualizar posición anterior
    
    ld  de,#0xC000
    ld  c, e_x(ix)
    ld  b, e_y(ix)

    call cpct_getScreenPtr_asm

    ld  e_lastVP_l(ix),l
    ld  e_lastVP_h(ix),h


    ld  hl,(puntero_2)   ;;ACTULIZAR LOS PUNTEROS NO HACER ESTO
    ld  bc,(puntero_1)

    ;;------------------------------------------
    ;;Pos del hole
    ;;------------------------------------------
    ld ix,#hole
    inc hl 
    ld  d,(hl)
    ld  e_x(ix),d
    inc hl
    ld  d,(hl)
    ld  e_y(ix),d
    inc hl
    ld  d,(hl)
    ld  e_ai_aim_x(ix),d
    ld  (puntero_2),hl   ;;ACTULIZAR LOS PUNTEROS NO HACER ESTO
    ld  (puntero_1),bc
    ld  a,#0
    cp  d
    jr  z,abierta
cerrada:
    ld  hl,#_hole_sp_0
    ld  e_pspr_l(ix),l
    ld  e_pspr_h(ix),h
jp siguiente
abierta:
    ld  hl,#_hole_sp_3
    ld  e_pspr_l(ix),l
    ld  e_pspr_h(ix),h
siguiente:
    ld  hl,(puntero_2)   ;;ACTULIZAR LOS PUNTEROS NO HACER ESTO
    ld  bc,(puntero_1)
    exx 
    ld  hl,#hole
    call man_entity_create
    exx
    ld  (puntero_2),hl   ;;ACTULIZAR LOS PUNTEROS NO HACER ESTO
    ld  (puntero_1),bc

    ;;;actualizar posición anterior
    
    ld  de,#0xC000
    ld  c, e_x(ix)
    ld  b, e_y(ix)

    call cpct_getScreenPtr_asm

    ld  e_lastVP_l(ix),l
    ld  e_lastVP_h(ix),h


    ld  hl,(puntero_2)   ;;ACTULIZAR LOS PUNTEROS NO HACER ESTO
    ld  bc,(puntero_1)
    inc hl
    
    ;;--------------------------------------------
    ;;Comienzo de los loops
    ;;--------------------------------------------
    ;;--------------------------------------------
    ;;Loop palas
    ;;--------------------------------------------
loop_enemigo_palas:
    ld  a,(hl)
    inc a
    jr  z,fin_loop_palas

    ld  ix,#pala
    ld  d,(hl)
    ld  e_x(ix),d
    inc hl
    ld  d,(hl)
    ld  e_y(ix),d
    ld  (puntero_2),hl   
    ld  (puntero_1),bc
    ld  hl,#pala
    call man_entity_create
    ld  hl,(puntero_2) 
    ld  bc,(puntero_1)
     ld  (puntero_2),hl   ;;ACTULIZAR LOS PUNTEROS NO HACER ESTO
    ld  (puntero_1),bc

    ;;;actualizar posición anterior
    
    ld  de,#0xC000
    ld  c, e_x(ix)
    ld  b, e_y(ix)

    call cpct_getScreenPtr_asm

    ld  e_lastVP_l(ix),l
    ld  e_lastVP_h(ix),h


    ld  hl,(puntero_2)   ;;ACTULIZAR LOS PUNTEROS NO HACER ESTO
    ld  bc,(puntero_1)
    inc hl
    jr loop_enemigo_palas

fin_loop_palas:
    ;;------------------------------------------------
    ;;Fin del bucle de la pala
    ;;-------------------------------------------------
    inc hl
    ;;--------------------------------------------
    ;;Loop enemigo horizontal
    ;;--------------------------------------------
    
loop_enemigo_hori:
    ld  a,(hl)
    inc a
    jr  z,fin_loop_enemigo_hori

    ld  ix,#villian_horizontal
    ld  d,(hl)
    ld  e_x(ix),d
    inc hl
    ld  d,(hl)
    ld  e_y(ix),d
    ld  (puntero_2),hl   
    ld  (puntero_1),bc
    ld  hl,#villian_horizontal
    call man_entity_create
    ld  hl,(puntero_2) 
    ld  bc,(puntero_1)
     ld  (puntero_2),hl   ;;ACTULIZAR LOS PUNTEROS NO HACER ESTO
    ld  (puntero_1),bc

    ;;;actualizar posición anterior
    
    ld  de,#0xC000
    ld  c, e_x(ix)
    ld  b, e_y(ix)

    call cpct_getScreenPtr_asm

    ld  e_lastVP_l(ix),l
    ld  e_lastVP_h(ix),h


    ld  hl,(puntero_2)   ;;ACTULIZAR LOS PUNTEROS NO HACER ESTO
    ld  bc,(puntero_1)
    inc hl
    jr loop_enemigo_hori

fin_loop_enemigo_hori:
    ;;------------------------------------------------
    ;;Fin del bucle del enemigo hori
    ;;-------------------------------------------------
    inc hl
    ;;--------------------------------------------
    ;;Loop enemigo vertical
    ;;--------------------------------------------
    
loop_enemigo_verti:
    ld  a,(hl)
    inc a
    jr  z,fin_loop_enemigo_verti

    ld  ix,#villian_vertical
    ld  d,(hl)
    ld  e_x(ix),d
    inc hl
    ld  d,(hl)
    ld  e_y(ix),d
    ld  (puntero_2),hl   
    ld  (puntero_1),bc
    ld  hl,#villian_vertical
    call man_entity_create
    ld  hl,(puntero_2) 
    ld  bc,(puntero_1)
     ld  (puntero_2),hl   ;;ACTULIZAR LOS PUNTEROS NO HACER ESTO
    ld  (puntero_1),bc

    ;;;actualizar posición anterior
    
    ld  de,#0xC000
    ld  c, e_x(ix)
    ld  b, e_y(ix)

    call cpct_getScreenPtr_asm

    ld  e_lastVP_l(ix),l
    ld  e_lastVP_h(ix),h


    ld  hl,(puntero_2)   ;;ACTULIZAR LOS PUNTEROS NO HACER ESTO
    ld  bc,(puntero_1)
    inc hl
    jr loop_enemigo_verti

fin_loop_enemigo_verti:
    ;;------------------------------------------------
    ;;Fin del bucle del enemigo hori
    ;;-------------------------------------------------
    inc hl 

 loop_cristal:
    ld  a,(hl)
    inc a
    jr  z,fin_loop_cristal

    ld  ix,#cristal
    ld  d,(hl)
    ld  e_x(ix),d
    inc hl
    ld  d,(hl)
    ld  e_y(ix),d
    ld  (puntero_2),hl   
    ld  (puntero_1),bc
    ld  hl,#cristal
    call man_entity_create
    ld  hl,(puntero_2) 
    ld  bc,(puntero_1)
       ld  (puntero_2),hl   ;;ACTULIZAR LOS PUNTEROS NO HACER ESTO
    ld  (puntero_1),bc

    ;;;actualizar posición anterior
    
    ld  de,#0xC000
    ld  c, e_x(ix)
    ld  b, e_y(ix)

    call cpct_getScreenPtr_asm

    ld  e_lastVP_l(ix),l
    ld  e_lastVP_h(ix),h


    ld  hl,(puntero_2)   ;;ACTULIZAR LOS PUNTEROS NO HACER ESTO
    ld  bc,(puntero_1)
    inc hl
    jr loop_cristal

fin_loop_cristal:
    ;;------------------------------------------------
    ;;Fin del bucle del cristal
    ;;-------------------------------------------------
 inc hl 

 loop_sombrero:
    ld  a,(hl)
    inc a
    jr  z,fin_loop_sombrero

    ld  ix,#sombrero
    ld  d,(hl)
    ld  e_x(ix),d
    inc hl
    ld  d,(hl)
    ld  e_y(ix),d
    ld  (puntero_2),hl   
    ld  (puntero_1),bc
    ld  hl,#sombrero
    call man_entity_create
    ld  hl,(puntero_2) 
    ld  bc,(puntero_1)
    ld  (puntero_2),hl   ;;ACTULIZAR LOS PUNTEROS NO HACER ESTO
    ld  (puntero_1),bc

    ;;;actualizar posición anterior
    
    ld  de,#0xC000
    ld  c, e_x(ix)
    ld  b, e_y(ix)

    call cpct_getScreenPtr_asm

    ld  e_lastVP_l(ix),l
    ld  e_lastVP_h(ix),h


    ld  hl,(puntero_2)   ;;ACTULIZAR LOS PUNTEROS NO HACER ESTO
    ld  bc,(puntero_1)
    inc hl
    jr loop_sombrero

fin_loop_sombrero:


    ld  (puntero_2),hl
    
    call sys_render_hud_update  
     
ret



set_velocity_to_zero:
    ld  e_vx(ix),#0
    ld  e_vy(ix),#0
ret

man_set_level:
    call man_entity_getArray
    ld  a,e_type(ix)
    and #e_type_reset
	sub #e_type_reset
    ret nz
    call cambiar_de_nivel
    call man_entity_getArray
    ld  e_type(ix),#e_type_MovAARenAAinputAAcollider
ret

reset_punteros::
    ld  hl,#_level_2
    ld  (puntero_1),hl
    ld  de,(puntero_1)
    ld  (puntero_2),de
ret