;;;-----------------------------LICENSE NOTICE------------------------------------
;;;    This file is part of LOOPED; An Amstrad CPC Game
;;;    Copyright (C) 2020  Miguel Ángel García Pérez (kupier@outlook.com) / Alejandro Gomariz Núñez (alejandro126g@gmail.com)
;;;
;;;    This program is free software: you can redistribute it and/or modify
;;;    it under the terms of the GNU General Public License as published by
;;;    the Free Software Foundation, either version 3 of the License, or
;;;    (at your option) any later version.
;;;
;;;    This program is distributed in the hope that it will be useful,
;;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;    GNU General Public License for more details.
;;;
;;;    You should have received a copy of the GNU General Public License
;;;------------------------------------------------------------------------------
.include "cpctelera.h.s"
.include "menu.h.s"
.include "sys/render.h.s"
.include "assets/assets.h.s"
.include "assets/screens/screen_menu_z.h.s"
.include "assets/screens/screen_credits.h.s"
.include "assets/screens/screen_instrucciones.h.s"


.include "cpct_functions.h.s"


string_menu:    .asciz  "GAME MENU"
string_press:   .asciz  "Enter to Start"

man_menu_init::
    call sys_eren_init

    ld  hl,#_screen_menu_z_end
    ld  de,#0xFFFF
    call cpct_zx7b_decrunch_s_asm
    ;ld  hl,#0x0002
    ;call cpct_setDrawCharM0_asm
    ;ld  iy,#string_menu
    ;X = 20
    ;Y = 80
    ;ld  hl,#0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;call cpct_drawStringM0_asm
;
    ;ld  hl,#0x0004
    ;call cpct_setDrawCharM0_asm
    ;ld  iy,#string_press
    ;X = 12
    ;Y = 120
    ;ld  hl,#0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
    ;call cpct_drawStringM0_asm
ret


man_menu_run::
    call cpct_scanKeyboard_asm
    ld  hl,#Key_3
    call cpct_isKeyPressed_asm
    jr  z,is_not_Key_I
    ;;Si la tecla Key C esta activada
    call man_menu_instructions
is_not_Key_I:
    ld  hl,#Key_2
    call cpct_isKeyPressed_asm
    jr  z,is_not_Key_C
    call man_menu_credtits
is_not_Key_C:
    ld  hl,#Key_1 ;;p de play
    call cpct_isKeyPressed_asm
    jr  z,man_menu_run
ret


man_menu_instructions:
    call sys_eren_init
    ld  hl,#_screen_instrucciones_end
    ld  de,#0xFFFF
    call cpct_zx7b_decrunch_s_asm
loop:
    call cpct_scanKeyboard_asm
    ld  hl,#Key_Esc
    call cpct_isKeyPressed_asm
    jr z,loop
    call man_menu_init
ret


man_menu_credtits:
    call sys_eren_init
    ld  hl,#_screen_credits_end
    ld  de,#0xFFFF
    call cpct_zx7b_decrunch_s_asm
loop_2:
    call cpct_scanKeyboard_asm
    ld  hl,#Key_Esc
    call cpct_isKeyPressed_asm
    jr z,loop_2
    call man_menu_init
ret