;;;-----------------------------LICENSE NOTICE------------------------------------
;;;    This file is part of LOOPED; An Amstrad CPC Game
;;;    Copyright (C) 2020  Miguel Ángel García Pérez (kupier@outlook.com) / Alejandro Gomariz Núñez (alejandro126g@gmail.com)
;;;
;;;    This program is free software: you can redistribute it and/or modify
;;;    it under the terms of the GNU General Public License as published by
;;;    the Free Software Foundation, either version 3 of the License, or
;;;    (at your option) any later version.
;;;
;;;    This program is distributed in the hope that it will be useful,
;;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;    GNU General Public License for more details.
;;;
;;;    You should have received a copy of the GNU General Public License
;;;------------------------------------------------------------------------------
.include "cpctelera.h.s"
.include "assets/assets.h.s"
.include "man/entity.h.s"
.include "cmp/entity.h.s"
.include "cpct_functions.h.s"
.include "sys/render.h.s"
.include "man/end_game.h.s"
.include "sys/scores.h.s"


.globl _mov
.globl _try
.globl _lvl
contadr: .dw #_numeros_sp_01



contadrlvl: .dw #_numeros_sp_01


contadr_try: .dw #_numeros_sp_01



hud_init_movs:: ;;cuando hay un retray o cuando se cambia de nivel
    ld hl,#_numeros_sp_01
    ld (contadr),hl

    ld hl,#_numeros_sp_00


    ld  ix,#_mov
    ld  0(ix),l
    ld  1(ix),h
    ld  5(ix),l
    ld  6(ix),h

ret


hud_init_lvls:: ;;cuando hay un retray o cuando se cambia de nivel
    ld hl,#_numeros_sp_01
    ld (contadrlvl),hl
   
    ld hl,#_numeros_sp_01


    ld  ix,#_lvl
    ld  0(ix),l
    ld  1(ix),h
    ld hl,#_numeros_sp_00
    ld  5(ix),l
    ld  6(ix),h
ret

hud_init_try:: ;;cuando hay un retray o cuando se cambia de nivel
    ld hl,#_numeros_sp_01
    ld (contadr_try),hl
   

    ld hl,#_numeros_sp_00

    ld  ix,#_try
    ld  0(ix),l
    ld  1(ix),h
    ld  5(ix),l
    ld  6(ix),h

ret


change_sprite_movements::
    
    ld  ix,#_mov
    ld  a,0(ix)
    ld  hl,#_numeros_sp_09
    sub l
    jr  nz,comprobada_
    ld  a,1(ix)
    sub h
    jr  nz,comprobada_
    ld  a,5(ix)
    sub l
    jr  nz,comprobada_
    ld  a,6(ix)
    sub h
    ret z
comprobada_:
    ld  ix,#_mov

    ld  l,0(ix)
  
    ld  h,1(ix)
    
    ld  iy,#contadr

    ld bc,#0x20
    add hl,bc
    ld  de,#_numeros_sp_09
    ex  de,hl
    add hl,bc
    ex  de,hl
    ld  a,d
    sub h
    jr nz,_no_sigue
    ld  a,e
    sub l
    jr nz,_no_sigue
    ;;Si sigue

    ld  ix,#_mov
    ld  hl,#_numeros_sp_00

    ld  0(ix),l
    ld  1(ix),h

    ld  hl,#contadr
    ld  e,(hl)
    ld  5(ix),e
    inc hl
    ld  d,(hl)
    ld  6(ix),d
    ld  bc,#0x20
    dec hl
    ex de,hl
    add hl,bc
    ld  (contadr),hl
;--------------------------------------------------------
;;;3ºcifra
;    ld  l,5(ix)
;    ld  h,6(ix)
;
;    ld bc,#0x20
;    add hl,bc
;
;    ld  a,#0x45
;    sub h
;    ret nz
;    ld  a,#0x00
;    sub l
;    ret nz
;    
;    ld  hl,#contadr_2
;    ld  e,(hl)
;    ld  10(ix),e
;    inc hl
;    ld  d,(hl)
;    ld  11(ix),d
;    ld  bc,#0x20
;    dec hl
;    ex de,hl
;    add hl,bc
;    ld  (contadr_2),hl
;    ld  hl,#_numeros_sp_01
;    ld  (contadr),hl

    call sys_render_hud_update
    ret
_no_sigue:
    ld  ix,#_mov

    ld  0(ix),l
    inc ix
    ld  0(ix),h
    call sys_render_hud_update

ret

;;------------------------------------------------------------------------------------


change_sprite_lvls::
    ld  ix,#_lvl
    ld  a,0(ix)
    ld  hl,#_numeros_sp_09
    sub l
    jr  nz,comprobada_lvl
    ld  a,1(ix)
    sub h
    jr  nz,comprobada_lvl
    ld  a,5(ix)
    sub l
    jr  nz,comprobada_lvl
    ld  a,6(ix)
    sub h
    ret z
comprobada_lvl:
    ld  ix,#_lvl

    ld  l,0(ix)
    inc ix
    ld  h,0(ix)

    

    ld bc,#0x20
    add hl,bc
     ld  de,#_numeros_sp_09
    ex  de,hl
    add hl,bc
    ex  de,hl
    ld  a,d
    sub h
    jr nz,_no_sigue_lvl
    ld  a,e
    sub l
    jr nz,_no_sigue_lvl
    ;;Si sigue

    ld  ix,#_lvl
    ld  hl,#_numeros_sp_00

    ld  0(ix),l
    ld  1(ix),h

    ld  hl,#contadrlvl
    ld  e,(hl)
    ld  5(ix),e
    inc hl
    ld  d,(hl)
    ld  6(ix),d
    ld  bc,#0x20
    dec hl
    ex de,hl
    add hl,bc
    ld  (contadrlvl),hl
    call sys_render_hud_update

    ret
_no_sigue_lvl:
    ld  ix,#_lvl

    ld  0(ix),l
    inc ix
    ld  0(ix),h
    call sys_render_hud_update

ret


;;;---------------------------------------------------------------------------------------


change_sprite_try::
   ld  ix,#_try
    ld  a,0(ix)
    ld  hl,#_numeros_sp_09
    sub l
    jr  nz,comprobada_try
    ld  a,1(ix)
    sub h
    jr  nz,comprobada_try
    ld  a,5(ix)
    sub l
    jr  nz,comprobada_try
    ld  a,6(ix)
    sub h
    ret z
comprobada_try:
    ld  ix,#_try

    ld  l,0(ix)
    inc ix
    ld  h,0(ix)



    ld bc,#0x20
    add hl,bc
     ld  de,#_numeros_sp_09
    ex  de,hl
    add hl,bc
    ex  de,hl
    ld  a,d
    sub h
    jr nz,_no_sigue_try
    ld  a,e
    sub l
    jr nz,_no_sigue_try
    ;;Si sigue

    ld  ix,#_try
    ld  hl,#_numeros_sp_00

    ld  0(ix),l
    ld  1(ix),h

    ld  hl,#contadr_try
    ld  e,(hl)
    ld  5(ix),e
    inc hl
    ld  d,(hl)
    ld  6(ix),d
    ld  bc,#0x20
    dec hl
    ex de,hl
    add hl,bc
    ld  (contadr_try),hl
    call sys_render_hud_update

    ret
_no_sigue_try:
    ld  ix,#_try

    ld  0(ix),l
    inc ix
    ld  0(ix),h
    call sys_render_hud_update

ret


plus_intentos::
    ld  a,(intentosTotales)
    inc a
    ld  (intentosTotales),a
    call hud_init_movs
    ld  a,#0
    ld  (movimientos_parciales),a
    call change_sprite_try

ret