;;;-----------------------------LICENSE NOTICE------------------------------------
;;;    This file is part of LOOPED; An Amstrad CPC Game
;;;    Copyright (C) 2020  Miguel Ángel García Pérez (kupier@outlook.com) / Alejandro Gomariz Núñez (alejandro126g@gmail.com)
;;;
;;;    This program is free software: you can redistribute it and/or modify
;;;    it under the terms of the GNU General Public License as published by
;;;    the Free Software Foundation, either version 3 of the License, or
;;;    (at your option) any later version.
;;;
;;;    This program is distributed in the hope that it will be useful,
;;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;    GNU General Public License for more details.
;;;
;;;    You should have received a copy of the GNU General Public License
;;;------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "man/entity.h.s"
.include "cmp/entity.h.s"
.include "man/game.h.s"
.include "man/game_Over.h.s"
.include "man/levels.h.s"
.include "cmp/level_cmp.h.s"
.include "sys/input.h.s"
.include "cpct_functions.h.s"
.include "cmp/hud.h.s"
.include "sys/scores.h.s"
.include "man/end_game.h.s"
sys_input_init::
    ret


sys_input_update:
    ld hl,#sys_input_update_one_entity
    ld  a,#e_type_input
    call man_entity_forall_matching
ret

sys_input_update_one_entity::

   

    call cpct_scanKeyboard_asm
  
    ld hl,#Key_Esc
    call cpct_isKeyPressed_asm
    jr z,ESC_not_pressed
    ESC_pressed:
    call are_you_sure_to_reset
ESC_not_pressed:

    ld  a,e_vx(ix)
    or  e_vx(ix)
    ret nz

    ld  a,e_vy(ix)
    or  e_vy(ix)
    ret nz

  
    

    ld  hl,#Key_O
    call cpct_isKeyPressed_asm
    jr  z, O_not_pressed

O_pressed:
    ld  e_vx(ix),#-1
    ld  e_vy(ix),#0
    ;ld  a,e_movimientos(ix)
    ;inc a
    ;ld  e_movimientos(ix),a
    ;;score
    call control_movimientos_parciales

    ;call plus_movements
    ld  ix,#_mov
    call change_sprite_movements
    call cpct_isAnyKeyPressed_asm
    or a 
    ret nz
O_not_pressed:
    ld  hl,#Key_P   
    call cpct_isKeyPressed_asm
    jr z,P_not_pressed
P_pressed:
    ld  e_vx(ix),#1
    ld  e_vy(ix),#0
    call control_movimientos_parciales
    ;call plus_movements
    ld  ix,#_mov
    call change_sprite_movements
    call cpct_isAnyKeyPressed_asm
    or a 
    ret nz
P_not_pressed:
    ld  hl,#Key_Q
    call cpct_isKeyPressed_asm
    jr z,Q_NotPressed
Q_pressed:
    ld e_vy(ix),#-2
    ld  e_vx(ix),#0
    
    call control_movimientos_parciales

    ld  ix,#_mov
    call change_sprite_movements
    call cpct_isAnyKeyPressed_asm
    or a 
    ret nz
Q_NotPressed:
    ld hl,#Key_A
    call cpct_isKeyPressed_asm
    jr z,A_not_pressed
A_pressed:
    ld e_vy(ix),#2
    ld  e_vx(ix),#0
    
    call control_movimientos_parciales

    ld  ix,#_mov
    call change_sprite_movements
    call cpct_isAnyKeyPressed_asm
    or a 
    ret nz
A_not_pressed:
    ld hl,#Key_R
    call cpct_isKeyPressed_asm
    jr z,R_not_pressed
R_pressed:
    ld  a,(fglobal)
    sub #1
    jr z,nivel_1
    ld  e_palas_obt(ix),#0
    ld  de,(puntero_1)
    ld  (puntero_2),de
   
    ;;si haces retry entonces
    call plus_intentos
    call cambiar_de_nivel
    jr R_not_pressed
nivel_1:
 call man_game_init
R_not_pressed:
ret
