;;;-----------------------------LICENSE NOTICE------------------------------------
;;;    This file is part of LOOPED; An Amstrad CPC Game
;;;    Copyright (C) 2020  Miguel Ángel García Pérez (kupier@outlook.com) / Alejandro Gomariz Núñez (alejandro126g@gmail.com)
;;;
;;;    This program is free software: you can redistribute it and/or modify
;;;    it under the terms of the GNU General Public License as published by
;;;    the Free Software Foundation, either version 3 of the License, or
;;;    (at your option) any later version.
;;;
;;;    This program is distributed in the hope that it will be useful,
;;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;    GNU General Public License for more details.
;;;
;;;    You should have received a copy of the GNU General Public License
;;;------------------------------------------------------------------------------
.include "cmp/entity.h.s"
.include "man/entity.h.s"
.include "cpctelera.h.s"

.module sys_entity_physics

screen_width    = 80
screen_height   = 192


sys_physics_init::
    ret

sys_physics_update::
ld hl, #sys_physics_update_one_entity
ld  a,#e_type_movable
call man_entity_forall_matching
ret

sys_physics_update_one_entity::


    ld  a,#screen_width
    sub e_w(ix)
    ld  c,a

    ld  a,e_x(ix)
    add e_vx(ix)
    cp  c
    jr  nc,invalid_x

valid_x:
    ld  e_x(ix),a
    jr  endif_x

invalid_x:
    ld  a,e_ai_aim_x(ix)
    inc a
    ld  e_ai_aim_x(ix),a
    
    ld  a,e_vx(ix)
    add #1
    jr  z,para_derecha_x

    
    ld  e_x(ix),#0
ret
para_derecha_x:
    ld a,e_x(ix)
    add a,c
    ld  e_x(ix),a


endif_x:

    ld  a,#screen_height
    sub e_h(ix)
    ld  c,a

    ld  a,e_y(ix)
    add e_vy(ix)
    cp  c
    jr  nc,invalid_y
    
valid_y:
    ld  e_y(ix),a
    jr  endif_y
invalid_y:
    ld  a,e_ai_aim_x(ix)
    inc a
    ld  e_ai_aim_x(ix),a

    ld  a,e_vy(ix)
    add #2
    jr  z,para_arriba_y

    ld  e_y(ix),#0
ret
para_arriba_y:
    ld a,e_y(ix)
    add a,c
    ld  e_y(ix),a

endif_y:
ret