;;;-----------------------------LICENSE NOTICE------------------------------------
;;;    This file is part of LOOPED; An Amstrad CPC Game
;;;    Copyright (C) 2020  Miguel Ángel García Pérez (kupier@outlook.com) / Alejandro Gomariz Núñez (alejandro126g@gmail.com)
;;;
;;;    This program is free software: you can redistribute it and/or modify
;;;    it under the terms of the GNU General Public License as published by
;;;    the Free Software Foundation, either version 3 of the License, or
;;;    (at your option) any later version.
;;;
;;;    This program is distributed in the hope that it will be useful,
;;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;    GNU General Public License for more details.
;;;
;;;    You should have received a copy of the GNU General Public License
;;;------------------------------------------------------------------------------
.include "cpctelera.h.s"
.include "cpct_functions.h.s"
.include "assets/assets.h.s"
.include "cmp/entity.h.s"
.include "man/entity.h.s"
.include "man/levels.h.s"
.include "sys/render.h.s"
.include "cmp/hud.h.s"


.module sys_entity_render


screen_start  = 0xC000



sys_eren_init::
    ld  c,#0

    call cpct_setVideoMode_asm
    ld  hl,#_palette
    ld  de,#16
    call cpct_setPalette_asm
    cpctm_setBorder_asm HW_BLACK

    ld  hl,#0xC000
    ld  de,#0xC001
    ld  bc,#0x4000-1
    ld  (hl),#0 
    ldir
ret


sys_eren_update::

    ld  hl,#sys_eren_render_entities
    ld  a,#e_type_render
    call man_entity_forall_matching
ret

sys_eren_update_entities::
    call sys_eren_render_entities
ret




sys_eren_render_entities::
    ;ld  a,e_type(ix)
    ;and #e_type_dead
    ;cp a
    ;ret nz

    ld  e,e_lastVP_l(ix)
    ld  d,e_lastVP_h(ix)
    ld  a,#0xcc
    ld  c,e_w(ix)
    ld  b,e_h(ix)
    push bc
    call cpct_drawSolidBox_asm

    ld  de,#screen_start
    ld  c, e_x(ix)
    ld  b, e_y(ix)

    call cpct_getScreenPtr_asm

    ld  e_lastVP_l(ix),l
    ld  e_lastVP_h(ix),h

    ex  de,hl
    ld  l,e_pspr_l(ix)
    ld  h,e_pspr_h(ix)
    pop bc
    call cpct_drawSprite_asm
ret


tilemap_init:

    ld  b, #25
    ld  c, #20
    ld  de, #20
    ld  hl, #_tiles_00
    call cpct_etm_setDrawTilemap4x8_ag_asm


    ld hl, #0xC000
    ld de, #_tilemap_01


    call cpct_etm_drawTilemap4x8_ag_asm 
ret

update_tilemap:

    ld  b, #25
    ld  c, #20
    ld  de, #20
    ld  hl, #_tiles_00
    call cpct_etm_setDrawTilemap4x8_ag_asm


    ld  hl, #0xC000
    ld  de,(mapsGobl)


    call cpct_etm_drawTilemap4x8_ag_asm 
ret


sys_render_hud_update::
    ld  hl,#sys_render_hud
    call man_entity_forall_hud
ret
;
sys_render_hud::
    ld  de,#screen_start
    ld  c,0(ix)  ;;Posiciones en bc de donde queremos el sprite

    ld  b,#192
    
    call cpct_getScreenPtr_asm

    ex  de,hl
    inc ix
    ld  c,0(ix)
    inc ix
    ld  b,0(ix)
    inc ix
    ld  l,0(ix)
    inc ix 
    ld  h,0(ix)
    call cpct_drawSprite_asm
    inc ix 
ret