;;;-----------------------------LICENSE NOTICE------------------------------------
;;;    This file is part of LOOPED; An Amstrad CPC Game
;;;    Copyright (C) 2020  Miguel Ángel García Pérez (kupier@outlook.com) / Alejandro Gomariz Núñez (alejandro126g@gmail.com)
;;;
;;;    This program is free software: you can redistribute it and/or modify
;;;    it under the terms of the GNU General Public License as published by
;;;    the Free Software Foundation, either version 3 of the License, or
;;;    (at your option) any later version.
;;;
;;;    This program is distributed in the hope that it will be useful,
;;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;    GNU General Public License for more details.
;;;
;;;    You should have received a copy of the GNU General Public License
;;;------------------------------------------------------------------------------
.include "man/entity.h.s"
.include "cmp/entity.h.s"
.include "man/end_game.h.s"

digito_3::   .db 0
digito_2::   .db 0
digito_1::   .db 0

movimientos_parciales:: .db 0

plus_movements::
;    ld  a,(digito_1)
;    sub a,#9
;    jr  z,top_primer_digito
;    ld  a,(digito_1)
;    inc a
;    ld  (digito_1),a
;    ret
;top_primer_digito:
;    ld  a,#0
;    ld  (digito_1),a
;    ld  a,(digito_2)
;    sub #9
;    jr  z,top_segundo_digito
;    ld  a,(digito_2)
;    inc a
;    ld  (digito_2),a
;    ret    
;
;top_segundo_digito:
;    ld  a,#0
;    ld  (digito_2),a
;    ld  a,(digito_3)
;    sub #9
;    ret z
;    ld  a,(digito_3)
;    inc a
;    ld  (digito_3),a
ret
;
movements_to_digits::
    ;;la podemos hacer generica pasandole por parametro hl-------
    ld  a,l
    sub #0
    jr  nz,loop
    ld  a,h
    sub #0
    ret z ;;Comprobamos que no sea 0000
loop:
    ;;primero miramos si el digito 1 tiene 9 para hacer carry
    ld  a,(digito_1)
    sub #9
    jr  z,da_cero_1 
    ld  a,(digito_1)
    inc a
    ld  (digito_1),a
    dec hl
    ld  a,l
    sub #0
    jr  nz,loop
    ld  a,h
    sub #0
    ret z
da_cero_1:
    ld  a,(digito_2)
    sub #9
    jr z,da_cero_2
    ld  a,#00
    ld  (digito_1),a
    ld  a,(digito_2)
    inc a
    ld  (digito_2),a
    dec hl
    ld  a,l
    sub #0
    jr  nz,loop
    ld  a,h
    sub #0
    ret z
da_cero_2:
    ld  a,(digito_3)
    inc a
    ld  (digito_3),a
    ld  a,#00
    ld  (digito_2),a
    ld  (digito_1),a
  
    dec hl
    ld  a,l
    sub #0
    jr  nz,loop
    ld  a,h
    sub #0
    ret z
ret

sum_parcial_to_total::
    
    ;;Ahora que tenemos el array le sumamos los parciales a los totales
    ;;comprobamos si 99 de movimientos parciales
    ld  hl,(movimientosTotales)
    ld  a,(movimientos_parciales)
    ld  c,a
    ld  b,#00
    add hl,bc
    ld  (movimientosTotales),hl
    ld  a,#0
    ld  (movimientos_parciales),a
ret

reset_digits::
    ld  a,#0
    ld  (digito_1),a
    ld  (digito_2),a
    ld  (digito_3),a

ret


control_movimientos_parciales::
    ld  a,(movimientos_parciales)
    sub #99
    jr  z,not_increment
    ld  a,(movimientos_parciales)
    inc a
    ld  (movimientos_parciales),a
    not_increment:
    ;ld  (movimientos_parciales),a

ret