;;;-----------------------------LICENSE NOTICE------------------------------------
;;;    This file is part of LOOPED; An Amstrad CPC Game
;;;    Copyright (C) 2020  Miguel Ángel García Pérez (kupier@outlook.com) / Alejandro Gomariz Núñez (alejandro126g@gmail.com)
;;;
;;;    This program is free software: you can redistribute it and/or modify
;;;    it under the terms of the GNU General Public License as published by
;;;    the Free Software Foundation, either version 3 of the License, or
;;;    (at your option) any later version.
;;;
;;;    This program is distributed in the hope that it will be useful,
;;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;    GNU General Public License for more details.
;;;
;;;    You should have received a copy of the GNU General Public License
;;;------------------------------------------------------------------------------
.include "man/entity.h.s"
.include "cmp/entity.h.s"
.include "cpctelera.h.s"
.include "cpct_collision.h.s"
.include "sys/cpct_collision.h.s"
.include "man/game_Over.h.s"
.include "man/animations.h.s"
.include "man/game.h.s"
.include "cmp/array_structure.h.s"
.include "assets/assets.h.s"
.include "man/levels.h.s"
.include "man/end_game.h.s"
.include "cmp/hud.h.s"



.module sys_collision_control



sys_collision_update::
    ld  hl,#sys_collision_update_one_entity
    ld  a,#e_type_collider
    call man_entity_forall_matching_pairing
ret

sys_collision_update_one_entity:
call sys_collision_check
call sys_collision_check_map
;call man_entity_getArray
;_next_ix: 
;    ;ld  e,(hl)
;    ;inc hl
;    ;ld  d,(hl)
;    ;inc hl
;;
;    ld  a,e_type(ix)
;    or  a
;    ret z
;
;    ;push hl
;    push ix
;    ;ld__ixl_e
;    ;ld__ixh_d
;
;_next_iy:
;    ;ld  e,(hl)
;    ;inc hl  
;    ;ld  d,(hl)
;    ;inc hl
;;
;    ld  a,e_type(iy)
;    or  a
;    jr  z,_trozo
;;
;    ;ld__iyl_e
;    ;ld__iyh_d
;    push iy
;    ld  bc,#sizeof_e
;    add iy,bc
;;
;;    call sys_collision_check
;;
;;    
;;    jr _next_iy
;;
;;_trozo: 
;;    pop ix
;;    pop iy
;;    ld  bc,#sizeof_e
;;    add ix,bc
;;    add iy,bc
;;    jr _next_ix
;
;call man_entity_getArrayIY
;                                                                  
;bucley:
;    ;;Primero comproamos las direcciones de memoria de ix y iy
;    ld__e_ixl
;    ld__d_ixh
;
;    ld__b_iyl
;    ld__c_iyh
;
;    ld  a,e
;    cp  a,b
;    jr  nz,not_equals
;
;    ld  bc,#sizeof_e
;    add ix,bc
;
;not_equals:
;
;    call sys_collision_check
;
;
ret
sys_collision_check_map::


ld      a, e_vy(ix)
or a
jp  z, map_izqder
add     #2
jr  z, arriba
;;;;;ABAJO;;;;;;;;;;;;;;
ld      a, e_y(ix) ;
add  #13 ;;(height personaje)
srl     a
srl     a
srl     a

ld      h, #0
ld      l, a
;; hl = hl*48

add     hl, hl
add     hl, hl
ld      d, h
ld      e, l
add     hl, hl
add     hl, hl
add     hl, de
ld a, e_x(ix)
srl  a
srl  a

add_hl_a
ld de, (mapsGobl)
add     hl, de


ld a, (hl) ;; A = tile indx on the foot of entity
and #0xF0
ret nz

ld  e_vy(ix),#0
ld  a,e_y(ix)
sub #2
ld  e_y(ix),a
 ld  e_ai_aim_x(ix),#0
call animation_personaje_stop
ret
arriba:
;;;;;arriba;;;;;;;;;;;;;;
ld      a, e_y(ix) ;
add  #1 
srl     a
srl     a
srl     a

ld      h, #0
ld      l, a
;; hl = hl*48
add     hl, hl
add     hl, hl
ld      d, h
ld      e, l
add     hl, hl
add     hl, hl
add     hl, de
ld a, e_x(ix)
srl  a
srl  a

add_hl_a
ld de, (mapsGobl)
add     hl, de


ld a, (hl) ;; A = tile indx on the foot of entity
and #0xF0
ret nz

ld  e_vy(ix),#0
ld  a,e_y(ix)
add #2
ld  e_y(ix),a
 ld  e_ai_aim_x(ix),#0
call animation_personaje_stop

ret


map_izqder:
ld      a, e_vx(ix)
or a
ret z
add #1
jr  z,map_left

ld      a, e_y(ix) ;
srl     a
srl     a
srl     a

ld      h, #0
ld      l, a
;; hl = hl*48

add     hl, hl
add     hl, hl
ld      d, h
ld      e, l
add     hl, hl
add     hl, hl
add     hl, de
ld a, e_x(ix)

add #6
srl  a
srl  a

add_hl_a
ld de, (mapsGobl)
add     hl, de


ld a, (hl) ;; A = tile indx on the foot of entity
and #0xF0
ret nz

ld  e_vx(ix),#0
ld  a,e_x(ix)
sub #1
ld  e_x(ix),a
 ld  e_ai_aim_x(ix),#0
call animation_personaje_stop

ret

map_left:
ld      a, e_y(ix) ;
srl     a
srl     a
srl     a

ld      h, #0
ld      l, a
;; hl = hl*48

add     hl, hl
add     hl, hl
ld      d, h
ld      e, l
add     hl, hl
add     hl, hl
add     hl, de

ld a, e_x(ix)

srl  a
srl  a

add_hl_a
ld de, (mapsGobl)
add     hl, de


ld a, (hl) ;; A = tile indx on the foot of entity
and #0xF0
ret nz

ld  e_vx(ix),#0
ld  a,e_x(ix)
add #1
ld  e_x(ix),a
 ld  e_ai_aim_x(ix),#0
call animation_personaje_stop

ret

sys_collision_check::

    ld  a,e_x(ix)
    add e_w(ix)
    sub e_x(iy)
    jr  c,__no_collision

    ld  a,e_x(iy)
    add e_w(iy)
    sub e_x(ix)
    jr  c,__no_collision

    ld  a,e_y(ix)
    add e_h(ix)
    sub e_y(iy)
    jr c,__no_collision

    ld  a,e_y(iy)
    add e_h(iy)
    sub e_y(ix)
    jr c,__no_collision

    
    call comprobar_esPersonaje
    ;call man_entity_4destruction
    ;;Comprobamos de que tipo es
    ;Si es un enemigo o si es una pared etc
   
no_es_personaje:
ld  a,e_collisionst(iy)
    or #e_collision_wall
    sub #e_collision_wall
jr z, is_a_wall
ret

    
__no_collision:

ret

comprobar_esPersonaje:
    ld  a,e_type(ix)
    and  #e_type_input
    sub  #e_type_input 
    jr  nz,no_es_personaje
    call found_character

ret


found_character:
    
    ;;Si es el personaje miramos con que ha colisionado
    ld  a,e_collisionst(iy)
    or #e_collision_wall
    sub #e_collision_wall
    jr  nz,is_not_a_wall
    call is_a_wall
    ret
is_not_a_wall:
    ld  a,e_collisionst(iy)
    or #e_collision_enemy
    sub #e_collision_enemy
    jr  nz,is_not_a_enemy
    call is_a_enemy
    ret
is_not_a_enemy:
    ld  a,e_collisionst(iy)
    or #e_collision_stairs
    sub #e_collision_stairs
    jr  nz,is_not_a_obj
    call is_a_stairs
    
is_not_a_obj:
    ld  a,e_collisionst(iy)
    or #e_collision_pala
    sub #e_collision_pala
    jr  nz,is_not_a_pala
    call is_a_pala
is_not_a_pala:
ret


is_a_wall:
    ld  e_ai_aim_x(ix),#0

    ld  a,e_vx(ix)
    or  a
    jr  z,upordown
    add a,#1 ;;Going to the left
    jr  z,going_to_the_left


    ld  e_vx(ix),#0
    ld  a,e_x(ix)
    sub #1
    ld  e_x(ix),a
    jr colision_enemiga
    ret
going_to_the_left:
    ld  e_vx(ix),#0
    ld  a,e_x(ix)
    inc a
    ld  e_x(ix),a
jr colision_enemiga
ret
upordown:
    ld  a,e_vy(ix)
    or a
    jr z, colision_enemiga
    add #2
    jr  z,going_to_the_up
    ;;Going to the down
    ld  e_vy(ix),#0
    ld  a,e_y(ix)
    sub #2
    ld  e_y(ix),a
    jr colision_enemiga
    ret
going_to_the_up:
    ld  e_vy(ix),#0
    ld  a,e_y(ix)
    add #2
    ld  e_y(ix),a

colision_enemiga:
   ld__d_iyh
   ld__e_iyl

   ld__ixh_d
   ld__ixl_e
   
ld e_collisionst(ix), #0x10


ret

is_a_enemy:
    ;call man_entity_4destruction
     ld  a,(fglobal)
    sub #1
    jr z,nivel_1
    ld  e_palas_obt(ix),#0
   
   
    ld  de,(puntero_1)
    ld  (puntero_2),de
    push ix
    call plus_intentos ;;;;;;;;
    pop ix
    call man_game_reset_lvl;;man_game_reset


    ret
nivel_1:
    call man_game_init
ret

is_a_stairs:
    ;;Miramos si el personaje tiene todas las palas que necesita para el nivel
    ld  h,e_pspr_h(iy)
    ld  l,e_pspr_l(iy)
    ld  de,#_sombrero_sp
    ld  a,h
    sub a,d
    jr  nz,seguir
    ld  a,l
    sub a,e
    jp  z,man_end_game_init
seguir:
    ld  a,e_ai_aim_x(iy)
    ld  b,e_palas_obt(ix)

    sub a,b
    jr  z,sube_de_nivel
    call hole_cerrado
    ret
sube_de_nivel:
    ld  a,e_ai_aim_y(ix)
    inc a
    ld  e_ai_aim_y(ix),a
    ld  a,(fglobal)
    dec a
    ret z
    ld	hl, (puntero_2)
    
    ld 	e,(hl)
    inc hl
    ld	d,(hl)
    ld  (puntero_2),hl

    ;call level_up
    ;call man_gameOver_init
ret

is_a_pala:
    ;;Si es una pala tenemos que incrementar el contador del personaje de palas
    ;;Y poner esa pala a dead para borrarla
    ld  d,e_palas_obt(ix)
    inc d
    ld  e_palas_obt(ix),d
    ;;Ahora ponemos esta pala a dead
    ld  e_type(iy),#e_type_dead


    call man_entity_getArray
    ld  bc,#20
looped:
    ld  a,e_collisionst(ix)
    or #e_collision_stairs
    sub #e_collision_stairs
    jr  z,foundit
    add ix,bc
    jr looped
foundit:
    ld  a,e_ai_aim_x(ix) ;;Este es el numero de palas que necesita para que se abra
    ld  a,d
    or a
    jr  nz, picar
    ld  hl,#_hole_sp_0
    ld  e_pspr_l(ix),l
    ld  e_pspr_h(ix),h
    ret

picar:
    ld  a,e_ai_aim_x(ix) ;;Este es el numero de palas que necesita para que se abra
    sub a,d 
    jr z, cerrada
    dec a
    jr  nz,picar2
    ld  hl,#_hole_sp_2
    ld  e_pspr_l(ix),l
    ld  e_pspr_h(ix),h
    ret
picar2:
    ld  hl,#_hole_sp_1
    ld  e_pspr_l(ix),l
    ld  e_pspr_h(ix),h
    ret
cerrada:
    ld  hl,#_hole_sp_3
    ld  e_pspr_l(ix),l
    ld  e_pspr_h(ix),h
ret

hole_cerrado:
    ld  e_ai_aim_x(ix),#0

    ld  a,e_vx(ix)
    or  a
    jr  z,h_upordown
    add a,#1 ;;Going to the left
    jr  z,h_going_to_the_left


    ld  e_vx(ix),#0
    ld  a,e_x(ix)
    sub #1
    ld  e_x(ix),a
    ret
h_going_to_the_left:
    ld  e_vx(ix),#0
    ld  a,e_x(ix)
    inc a
    ld  e_x(ix),a
    ret
h_upordown:
    ld  a,e_vy(ix)
    or a
    add #2
    jr  z,h_going_to_the_up

    ld  e_vy(ix),#0
    ld  a,e_y(ix)
    sub #2
    ld  e_y(ix),a
    ret
h_going_to_the_up:
    ld  e_vy(ix),#0
    ld  a,e_y(ix)
    add #2
    ld  e_y(ix),a


ret